<?php

Yii::import('application.modules.core_models.models._base.BaseApprovableModel');

/**
 * This is the model base class for the table "provider_rating_abuse".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderRatingAbuse".
 *
 * Columns in table "provider_rating_abuse" available as properties of the model,
 * followed by relations of table "provider_rating_abuse" available as properties of the model.
 *
 * @property integer $id
 * @property integer $rating_id
 * @property string $abuse_report
 * @property string $status
 * @property string $status_comments
 * @property string $date_added
 * @property string $date_updated
 *
 * @property ProviderRating $rating
 */
abstract class BaseProviderRatingAbuse extends BaseApprovableModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_rating_abuse';
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('rating_id, abuse_report', 'required'),
            array('rating_id', 'numerical', 'integerOnly' => true),
            array('abuse_report, status_comments', 'length', 'max' => 255),
            array('status', 'length', 'max' => 1),
            array('date_added, date_updated', 'safe'),
            array('status, status_comments, date_added, date_updated', 'default', 'setOnEmpty' => true,
                'value' => null),
            array('id, rating_id, abuse_report, status, status_comments, date_added, date_updated', 'safe',
                'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'rating' => array(self::BELONGS_TO, 'ProviderRating', 'rating_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'rating_id' => Yii::t('app', 'Rating'),
            'abuse_report' => Yii::t('app', 'Abuse Report'),
            'status' => Yii::t('app', 'Status'),
            'status_comments' => Yii::t('app', 'Status Comments'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'provider_id' => Yii::t('app', 'Provider'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        //this is to enable eager loading
        $criteria->with = array('rating');

        //$criteria->compare('id', $this->id);
        $criteria->compare('rating_id', $this->rating_id);
        $criteria->compare('abuse_report', $this->abuse_report, true);
        $criteria->compare('t.status', $this->status, true);
        $criteria->compare('status_comments', $this->status_comments, true);
        $criteria->compare('t.date_added', $this->date_added, true);
        $criteria->compare('t.date_updated', $this->date_updated, true);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderRatingAbuse|ProviderRatingAbuses', $n);
    }

}
